//------------------------------------------------------------------------------
//! @file SyntaxFwd.h
//! @brief Forward declarations for syntax node types
//
// SPDX-FileCopyrightText: Michael Popoloski
// SPDX-License-Identifier: MIT
//------------------------------------------------------------------------------
#pragma once

namespace slang::syntax {

class SyntaxNode;
struct ExpressionSyntax;
struct DataTypeSyntax;
struct TimingControlSyntax;
struct SequenceExprSyntax;
struct PropertyExprSyntax;
struct EqualsValueClauseSyntax;
struct AttributeSpecSyntax;
struct AttributeInstanceSyntax;
struct NamedLabelSyntax;
struct StatementSyntax;
struct MemberSyntax;
struct ArgumentSyntax;
struct EmptyArgumentSyntax;
struct OrderedArgumentSyntax;
struct NamedArgumentSyntax;
struct ArgumentListSyntax;
struct ParamAssignmentSyntax;
struct OrderedParamAssignmentSyntax;
struct NamedParamAssignmentSyntax;
struct ParameterValueAssignmentSyntax;
struct PatternSyntax;
struct ParenthesizedPatternSyntax;
struct VariablePatternSyntax;
struct WildcardPatternSyntax;
struct ExpressionPatternSyntax;
struct TaggedPatternSyntax;
struct StructurePatternMemberSyntax;
struct OrderedStructurePatternMemberSyntax;
struct NamedStructurePatternMemberSyntax;
struct StructurePatternSyntax;
struct MatchesClauseSyntax;
struct ConditionalPatternSyntax;
struct ConditionalPredicateSyntax;
struct AssignmentPatternSyntax;
struct SimpleAssignmentPatternSyntax;
struct AssignmentPatternItemSyntax;
struct StructuredAssignmentPatternSyntax;
struct ReplicatedAssignmentPatternSyntax;
struct BadExpressionSyntax;
struct PrimaryExpressionSyntax;
struct PrefixUnaryExpressionSyntax;
struct PostfixUnaryExpressionSyntax;
struct BinaryExpressionSyntax;
struct MinTypMaxExpressionSyntax;
struct TaggedUnionExpressionSyntax;
struct ValueRangeExpressionSyntax;
struct RangeListSyntax;
struct InsideExpressionSyntax;
struct ConditionalExpressionSyntax;
struct AssignmentPatternExpressionSyntax;
struct SelectorSyntax;
struct BitSelectSyntax;
struct RangeSelectSyntax;
struct ElementSelectSyntax;
struct NameSyntax;
struct IdentifierNameSyntax;
struct SystemNameSyntax;
struct IdentifierSelectNameSyntax;
struct EmptyIdentifierNameSyntax;
struct KeywordNameSyntax;
struct ClassNameSyntax;
struct ScopedNameSyntax;
struct LiteralExpressionSyntax;
struct IntegerVectorExpressionSyntax;
struct EmptyQueueExpressionSyntax;
struct ConcatenationExpressionSyntax;
struct MultipleConcatenationExpressionSyntax;
struct StreamExpressionWithRangeSyntax;
struct StreamExpressionSyntax;
struct StreamingConcatenationExpressionSyntax;
struct ParenthesizedExpressionSyntax;
struct NewArrayExpressionSyntax;
struct NewClassExpressionSyntax;
struct CopyClassExpressionSyntax;
struct SuperNewDefaultedArgsExpressionSyntax;
struct ElementSelectExpressionSyntax;
struct MemberAccessExpressionSyntax;
struct InvocationExpressionSyntax;
struct CastExpressionSyntax;
struct SignedCastExpressionSyntax;
struct DelaySyntax;
struct Delay3Syntax;
struct OneStepDelaySyntax;
struct EventControlSyntax;
struct IffEventClauseSyntax;
struct EventExpressionSyntax;
struct SignalEventExpressionSyntax;
struct BinaryEventExpressionSyntax;
struct ParenthesizedEventExpressionSyntax;
struct ImplicitEventControlSyntax;
struct EventControlWithExpressionSyntax;
struct RepeatedEventControlSyntax;
struct TimingControlExpressionSyntax;
struct DimensionSpecifierSyntax;
struct RangeDimensionSpecifierSyntax;
struct WildcardDimensionSpecifierSyntax;
struct ColonExpressionClauseSyntax;
struct QueueDimensionSpecifierSyntax;
struct VariableDimensionSyntax;
struct DeclaratorSyntax;
struct DataDeclarationSyntax;
struct ForwardTypeRestrictionSyntax;
struct TypedefDeclarationSyntax;
struct ForwardTypedefDeclarationSyntax;
struct NetStrengthSyntax;
struct ChargeStrengthSyntax;
struct DriveStrengthSyntax;
struct PullStrengthSyntax;
struct NetDeclarationSyntax;
struct UserDefinedNetDeclarationSyntax;
struct WithFunctionClauseSyntax;
struct NetTypeDeclarationSyntax;
struct PackageImportItemSyntax;
struct PackageImportDeclarationSyntax;
struct PackageExportDeclarationSyntax;
struct PackageExportAllDeclarationSyntax;
struct ParameterDeclarationBaseSyntax;
struct ParameterDeclarationSyntax;
struct EqualsTypeClauseSyntax;
struct TypeAssignmentSyntax;
struct TypeParameterDeclarationSyntax;
struct ParameterDeclarationStatementSyntax;
struct PortHeaderSyntax;
struct PortDeclarationSyntax;
struct GenvarDeclarationSyntax;
struct FunctionPortBaseSyntax;
struct DefaultFunctionPortSyntax;
struct FunctionPortSyntax;
struct FunctionPortListSyntax;
struct IntegerTypeSyntax;
struct KeywordTypeSyntax;
struct NamedTypeSyntax;
struct StructUnionMemberSyntax;
struct StructUnionTypeSyntax;
struct EnumTypeSyntax;
struct TypeReferenceSyntax;
struct DotMemberClauseSyntax;
struct VirtualInterfaceTypeSyntax;
struct ImplicitTypeSyntax;
struct DeferredAssertionSyntax;
struct ElseClauseSyntax;
struct ActionBlockSyntax;
struct ImmediateAssertionStatementSyntax;
struct DisableIffSyntax;
struct PropertySpecSyntax;
struct ConcurrentAssertionStatementSyntax;
struct ConcurrentAssertionMemberSyntax;
struct ImmediateAssertionMemberSyntax;
struct EmptyStatementSyntax;
struct ConditionalStatementSyntax;
struct CaseItemSyntax;
struct DefaultCaseItemSyntax;
struct PatternCaseItemSyntax;
struct StandardCaseItemSyntax;
struct CaseStatementSyntax;
struct ForeverStatementSyntax;
struct LoopStatementSyntax;
struct DoWhileStatementSyntax;
struct ForVariableDeclarationSyntax;
struct ForLoopStatementSyntax;
struct ForeachLoopListSyntax;
struct ForeachLoopStatementSyntax;
struct ReturnStatementSyntax;
struct JumpStatementSyntax;
struct TimingControlStatementSyntax;
struct ExpressionStatementSyntax;
struct VoidCastedCallStatementSyntax;
struct ProceduralAssignStatementSyntax;
struct ProceduralDeassignStatementSyntax;
struct DisableStatementSyntax;
struct DisableForkStatementSyntax;
struct NamedBlockClauseSyntax;
struct BlockStatementSyntax;
struct WaitStatementSyntax;
struct WaitForkStatementSyntax;
struct WaitOrderStatementSyntax;
struct RandCaseItemSyntax;
struct RandCaseStatementSyntax;
struct RsProdSyntax;
struct RsProdItemSyntax;
struct RsCodeBlockSyntax;
struct RsElseClauseSyntax;
struct RsIfElseSyntax;
struct RsRepeatSyntax;
struct RsCaseItemSyntax;
struct DefaultRsCaseItemSyntax;
struct StandardRsCaseItemSyntax;
struct RsCaseSyntax;
struct RandJoinClauseSyntax;
struct RsWeightClauseSyntax;
struct RsRuleSyntax;
struct ProductionSyntax;
struct RandSequenceStatementSyntax;
struct EventTriggerStatementSyntax;
struct PortListSyntax;
struct NonAnsiPortSyntax;
struct PortExpressionSyntax;
struct PortReferenceSyntax;
struct PortConcatenationSyntax;
struct EmptyNonAnsiPortSyntax;
struct ImplicitNonAnsiPortSyntax;
struct ExplicitNonAnsiPortSyntax;
struct NonAnsiPortListSyntax;
struct InterfacePortHeaderSyntax;
struct VariablePortHeaderSyntax;
struct NetPortHeaderSyntax;
struct ImplicitAnsiPortSyntax;
struct ExplicitAnsiPortSyntax;
struct AnsiPortListSyntax;
struct WildcardPortListSyntax;
struct ParameterPortListSyntax;
struct ModuleHeaderSyntax;
struct ModuleDeclarationSyntax;
struct AnonymousProgramSyntax;
struct EmptyMemberSyntax;
struct ProceduralBlockSyntax;
struct GenerateRegionSyntax;
struct LoopGenerateSyntax;
struct IfGenerateSyntax;
struct CaseGenerateSyntax;
struct GenerateBlockSyntax;
struct DividerClauseSyntax;
struct TimeUnitsDeclarationSyntax;
struct PortConnectionSyntax;
struct EmptyPortConnectionSyntax;
struct OrderedPortConnectionSyntax;
struct NamedPortConnectionSyntax;
struct WildcardPortConnectionSyntax;
struct InstanceNameSyntax;
struct HierarchicalInstanceSyntax;
struct HierarchyInstantiationSyntax;
struct PrimitiveInstantiationSyntax;
struct CheckerInstantiationSyntax;
struct CheckerInstanceStatementSyntax;
struct BindTargetListSyntax;
struct BindDirectiveSyntax;
struct ClassSpecifierSyntax;
struct FunctionPrototypeSyntax;
struct FunctionDeclarationSyntax;
struct EqualsAssertionArgClauseSyntax;
struct AssertionItemPortSyntax;
struct AssertionItemPortListSyntax;
struct LetDeclarationSyntax;
struct DefaultExtendsClauseArgSyntax;
struct ExtendsClauseSyntax;
struct ImplementsClauseSyntax;
struct ClassDeclarationSyntax;
struct ClassPropertyDeclarationSyntax;
struct ClassMethodDeclarationSyntax;
struct ClassMethodPrototypeSyntax;
struct ContinuousAssignSyntax;
struct DefParamAssignmentSyntax;
struct DefParamSyntax;
struct ModportClockingPortSyntax;
struct ModportPortSyntax;
struct ModportNamedPortSyntax;
struct ModportExplicitPortSyntax;
struct ModportSimplePortListSyntax;
struct ModportSubroutinePortSyntax;
struct ModportSubroutinePortListSyntax;
struct ModportItemSyntax;
struct ModportDeclarationSyntax;
struct ClockingSkewSyntax;
struct ClockingDirectionSyntax;
struct DefaultSkewItemSyntax;
struct ClockingItemSyntax;
struct ClockingDeclarationSyntax;
struct DefaultClockingReferenceSyntax;
struct DefaultDisableDeclarationSyntax;
struct DPIImportSyntax;
struct DPIExportSyntax;
struct ElabSystemTaskSyntax;
struct UdpPortDeclSyntax;
struct UdpOutputPortDeclSyntax;
struct UdpInputPortDeclSyntax;
struct UdpPortListSyntax;
struct AnsiUdpPortListSyntax;
struct NonAnsiUdpPortListSyntax;
struct WildcardUdpPortListSyntax;
struct UdpInitialStmtSyntax;
struct UdpFieldBaseSyntax;
struct UdpEdgeFieldSyntax;
struct UdpSimpleFieldSyntax;
struct UdpEntrySyntax;
struct UdpBodySyntax;
struct UdpDeclarationSyntax;
struct SpecparamDeclaratorSyntax;
struct SpecparamDeclarationSyntax;
struct PathSuffixSyntax;
struct SimplePathSuffixSyntax;
struct EdgeSensitivePathSuffixSyntax;
struct PathDescriptionSyntax;
struct PathDeclarationSyntax;
struct ConditionalPathDeclarationSyntax;
struct IfNonePathDeclarationSyntax;
struct PulseStyleDeclarationSyntax;
struct TimingCheckArgSyntax;
struct EmptyTimingCheckArgSyntax;
struct EdgeDescriptorSyntax;
struct EdgeControlSpecifierSyntax;
struct TimingCheckEventConditionSyntax;
struct TimingCheckEventArgSyntax;
struct ExpressionTimingCheckArgSyntax;
struct SystemTimingCheckSyntax;
struct SpecifyBlockSyntax;
struct NetAliasSyntax;
struct ExternModuleDeclSyntax;
struct ExternUdpDeclSyntax;
struct ExternInterfaceMethodSyntax;
struct ConstraintItemSyntax;
struct DistWeightSyntax;
struct DistItemBaseSyntax;
struct DistItemSyntax;
struct DefaultDistItemSyntax;
struct DistConstraintListSyntax;
struct ExpressionOrDistSyntax;
struct ExpressionConstraintSyntax;
struct UniquenessConstraintSyntax;
struct ImplicationConstraintSyntax;
struct ElseConstraintClauseSyntax;
struct ConditionalConstraintSyntax;
struct LoopConstraintSyntax;
struct DisableConstraintSyntax;
struct SolveBeforeConstraintSyntax;
struct ConstraintBlockSyntax;
struct ConstraintPrototypeSyntax;
struct ConstraintDeclarationSyntax;
struct ParenExpressionListSyntax;
struct ArrayOrRandomizeMethodExpressionSyntax;
struct WithFunctionSampleSyntax;
struct BlockEventExpressionSyntax;
struct BinaryBlockEventExpressionSyntax;
struct PrimaryBlockEventExpressionSyntax;
struct BlockCoverageEventSyntax;
struct CovergroupDeclarationSyntax;
struct CoverageOptionSyntax;
struct CoverageIffClauseSyntax;
struct CoverpointSyntax;
struct CoverageBinInitializerSyntax;
struct DefaultCoverageBinInitializerSyntax;
struct WithClauseSyntax;
struct ExpressionCoverageBinInitializerSyntax;
struct RangeCoverageBinInitializerSyntax;
struct IdWithExprCoverageBinInitializerSyntax;
struct TransRepeatRangeSyntax;
struct TransRangeSyntax;
struct TransSetSyntax;
struct TransListCoverageBinInitializerSyntax;
struct CoverageBinsArraySizeSyntax;
struct CoverageBinsSyntax;
struct CoverCrossSyntax;
struct BinsSelectExpressionSyntax;
struct IntersectClauseSyntax;
struct BinsSelectConditionExprSyntax;
struct UnaryBinsSelectExprSyntax;
struct BinaryBinsSelectExprSyntax;
struct ParenthesizedBinsSelectExprSyntax;
struct SimpleBinsSelectExprSyntax;
struct BinSelectWithFilterExprSyntax;
struct BinsSelectionSyntax;
struct SequenceRepetitionSyntax;
struct SimpleSequenceExprSyntax;
struct SequenceMatchListSyntax;
struct ParenthesizedSequenceExprSyntax;
struct BinarySequenceExprSyntax;
struct FirstMatchSequenceExprSyntax;
struct ClockingSequenceExprSyntax;
struct DelayedSequenceElementSyntax;
struct DelayedSequenceExprSyntax;
struct SimplePropertyExprSyntax;
struct ParenthesizedPropertyExprSyntax;
struct StrongWeakPropertyExprSyntax;
struct UnaryPropertyExprSyntax;
struct UnarySelectPropertyExprSyntax;
struct BinaryPropertyExprSyntax;
struct ClockingPropertyExprSyntax;
struct AcceptOnPropertyExprSyntax;
struct ElsePropertyClauseSyntax;
struct ConditionalPropertyExprSyntax;
struct PropertyCaseItemSyntax;
struct DefaultPropertyCaseItemSyntax;
struct StandardPropertyCaseItemSyntax;
struct CasePropertyExprSyntax;
struct LocalVariableDeclarationSyntax;
struct PropertyDeclarationSyntax;
struct SequenceDeclarationSyntax;
struct CheckerDeclarationSyntax;
struct CheckerDataDeclarationSyntax;
struct CompilationUnitSyntax;
struct LibraryMapSyntax;
struct DirectiveSyntax;
struct SimpleDirectiveSyntax;
struct IncludeDirectiveSyntax;
struct ConditionalDirectiveExpressionSyntax;
struct NamedConditionalDirectiveExpressionSyntax;
struct UnaryConditionalDirectiveExpressionSyntax;
struct BinaryConditionalDirectiveExpressionSyntax;
struct ParenthesizedConditionalDirectiveExpressionSyntax;
struct ConditionalBranchDirectiveSyntax;
struct UnconditionalBranchDirectiveSyntax;
struct MacroArgumentDefaultSyntax;
struct MacroFormalArgumentSyntax;
struct MacroFormalArgumentListSyntax;
struct DefineDirectiveSyntax;
struct MacroActualArgumentSyntax;
struct MacroActualArgumentListSyntax;
struct MacroUsageSyntax;
struct TimeScaleDirectiveSyntax;
struct DefaultNetTypeDirectiveSyntax;
struct UnconnectedDriveDirectiveSyntax;
struct DefaultDecayTimeDirectiveSyntax;
struct DefaultTriregStrengthDirectiveSyntax;
struct LineDirectiveSyntax;
struct UndefDirectiveSyntax;
struct BeginKeywordsDirectiveSyntax;
struct PragmaExpressionSyntax;
struct SimplePragmaExpressionSyntax;
struct NameValuePragmaExpressionSyntax;
struct NumberPragmaExpressionSyntax;
struct ParenPragmaExpressionSyntax;
struct PragmaDirectiveSyntax;
struct ConfigCellIdentifierSyntax;
struct ConfigRuleClauseSyntax;
struct ConfigLiblistSyntax;
struct ConfigUseClauseSyntax;
struct ConfigRuleSyntax;
struct DefaultConfigRuleSyntax;
struct ConfigInstanceIdentifierSyntax;
struct InstanceConfigRuleSyntax;
struct CellConfigRuleSyntax;
struct ConfigDeclarationSyntax;
struct FilePathSpecSyntax;
struct LibraryIncDirClauseSyntax;
struct LibraryDeclarationSyntax;
struct LibraryIncludeStatementSyntax;

}
